#!/usr/bin/env python
# encoding=utf-8 (pep 0263)

from linked_lists import Cons, Nil

def solution(n=8):
    if n == 0:
        yield Nil
    else:
        for others in solution(n-1):
            for x in range(8):
                for y in range(8):
                    if noattack(x, y, others):
                        yield Cons((x, y), others)

def noattack(x, y, others):
    if others == Nil:
        return True
    else:
        x1, y1 = others.head
        return x != x1 and y != y1 and y1-y != x1-x and y1-y != x-x1 and \
               noattack(x, y, others.tail)

def tisknireseni(reseni):
    return ["%d/%d" % (x+1, y+1) for (x, y) in reseni]

# demonstracni vypis
if __name__ == "__main__":
    print("PROBLEM OSMI DAM I")
    print("Volani tisknireseni(next(solution())) : %s" % \
            tisknireseni(next(solution())))
